﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcApplication1.Models;

namespace MvcApplication1.Controllers
{
    public class FishController : Controller
    {
     // controller passes on all storage work to the service
     public IFishService _fishService { get; set; }

     // when testing we can use this constructor and pass in a mock service
     // (although our currrent service is pretty mocky, but you get the idea)
     public FishController(IFishService fishService)
     {
      _fishService = fishService;
     }
     //
        // GET: /Fish/

        public ActionResult Index()
        {
            return View(_fishService.ListFish() );
        }

        // GET: /Fish/
        // returns json for jquery templates. All functions here are callable by javascript by constructing (say) an object in javascript with the relevant properties (id and name) and then calling (say) edit. However javascript needs its own methods if it wants something different returned, as in this case
     // eg (this is jquery / javascript code)
     // var fish = {id: 1, Name: "Cedd"}
     // $.ajax({url: '/Fish/Edit/1',
     // type: 'POST',
     // data: JSON.stringify(fish),
     // dataType: 'json',
     // contentType: "application/json; charset=utf-8",
     // success: function {alert("saved");}
     // error: function {alert("error");}
     // }
        public JsonResult JsonIndex()
        {
         return Json(_fishService.ListFish(), JsonRequestBehavior.AllowGet);
        }
        
     //
        // GET: /Fish/Details/5

        public ActionResult Details(int id)
        {
            return View();
        }

        //
        // GET: /Fish/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Fish/Create

        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
        
        //
        // GET: /Fish/Edit/5
 
        public ActionResult Edit(int id)
        {
            return View(_fishService.GetFish(id));
        }

        //
        // POST: /Fish/Edit/5

        [HttpPost]
        // mvc can convert the formcollection to an object (see commented function below for code without this)
        // the validation attributes are used when doing this
        // this makes unit testing slightly harder as we have to set up a form collection in order to get the system to do the model binding
        public ActionResult Edit(Fish fishToEdit)
        {
         if ((ModelState.IsValid) && (_fishService.EditFish(fishToEdit)))
         {
          return RedirectToAction("Index");
         }
         return View("Edit"); // return to the same view to allow user to correct validation mistakes
        }

/*        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here
 can use updatemodel() or tryupdatemodel() to do the binding (based on the attributes on the fish class) here
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
     */
        //
        // GET: /Fish/Delete/5
 
        public ActionResult Delete(int id)
        {
            return View();
        }

        //
        // POST: /Fish/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
    }
}
