﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using StructureMap;
using MvcApplication1.Models;
using MvcApplication1.Controllers;

namespace MvcApplication1
{
 // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
 // visit http://go.microsoft.com/?LinkId=9394801

 public class MvcApplication : System.Web.HttpApplication
 {
  public static void RegisterGlobalFilters(GlobalFilterCollection filters)
  {
   filters.Add(new HandleErrorAttribute());
  }

  public static void RegisterRoutes(RouteCollection routes)
  {
   routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

   // if we supply a route here that also matches the default route this route can fail the validation (not an int id)
   // but then the default route still matches so we don't get the desired effect
   // the order of routes here is important. first match wins.
   routes.MapRoute(
      "Bug",
      "bug/{id}",
      new { controller = "Home", action = "bug" }, // set controller to home and method to bug
      new { id = @"\d+" } // pass in id, this is a regular expression that matches integers
     );

   routes.MapRoute(
       "Default", // Route name
       "{controller}/{action}/{id}", // URL with parameters
       new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
   );

  }

  protected void Application_Start()
  {
   // Initialize the static ObjectFactory container (a structuremap thing)
   ObjectFactory.Initialize(x =>
   {
    x.For<IFishService>().Use<FishService>();
   });
   ControllerBuilder.Current.SetControllerFactory(new IocControllerFactory());
   
   AreaRegistration.RegisterAllAreas();

   RegisterGlobalFilters(GlobalFilters.Filters);
   RegisterRoutes(RouteTable.Routes);
  }
 }
}